// #autoload
// #name = DioSniper
// #version = 3.4
// #date = 12/10/2001 2:02AM
// #status = release
// #author = |Rx|Diogenes
// #warrior = Diogenes
// #email = diogenes@tribalpharmacy.com
// #web = http://www.tribalpharmacy.com
// #description = Full screen Sniper Reticle, along with sniper rifle use option
// #category = DioScripts
// #include = support/loadout.cs
// #config = DioSniperConfig
// #credits = DEbig3's HideRifle
// #credits = JJJ for the idea

package DioSniper {

function clientCmdShowVehicleGauges(%vehType, %node){
	parent::clientCmdShowVehicleGauges(%vehType, %node);
	$DioSniper::InVehicle = true;
}

function clientCmdVehicleDismount(){
	parent::clientCmdVehicleDismount();
	$DioSniper::InVehicle = false;
}

function toggleZoom (%val){
	if(%val){
		DioSniper::On();
	}

	else{
		DioSniper::Off();
	}
	parent::toggleZoom(%val);
}

function zoomControlToggle (%val){
	if(%val){
		DioSniper::On();
	}

	else{
		DioSniper::Off();
	}
	parent::zoomControlToggle(%val);
}	

function DioSniper::On(%this){
	$DioSniper::Engaged = true;
	if(!$DioSniper::InVehicle){
		if($pref::DioSniper::UseLaser){
			if(loadout.isLoadoutWeapon("SniperRifle")){
				$DioSniper::OldWeapon = loadout.getCurrentWeapon();
				if($pref::DioSniper::NotOnCG && $DioSniper::OldWeapon $= "Chaingun"){
					return;
				}
				DioSniperHUD.setVisible(1);
				reticleHud.setVisible(0);
				use("SniperRifle");
				$pref::Player::renderMyItems = "0";
			}
		}
		
		else{
			if(loadout.getCurrentWeapon() $= "SniperRifle"){
				DioSniperHUD.setVisible(1);
				reticleHud.setVisible(0);
				$pref::Player::renderMyItems = "0";
			}
		}
	}
}

function DioSniper::Off(%this){
	$DioSniper::Engaged = false;
	DioSniperHUD.setVisible(0);
	reticleHud.setVisible(1);
	$pref::Player::renderMyItems = "1";
	if($pref::DioSniper::UseLaser){
		use($DioSniper::OldWeapon);
	}
	$DioSniper::OldWeapon = "";
}

function DioSniperCheck(%weapon){
	if($DioSniper::Engaged){
		if(%weapon !$="SniperRifle"){
			DioSniperHUD.setVisible(0);
			reticleHud.setVisible(1);
			$pref::Player::renderMyItems = "1";
		}
		else{
			DioSniperHUD.setVisible(1);
			reticleHud.setVisible(0);
			$pref::Player::renderMyItems = "0";
		}
	}
}

function DioSniper::Start() {
	%DioSniper::X = getword($pref::Video::resolution, 0);
	%DioSniper::Y = getword($pref::Video::resolution, 1);
	
	%DioSniper::Size = %DioSniper::X @ " " @ %DioSniper::Y;
	
	%DioSniper::Pos = ("0 0");
	
	$DioSniper = new ShellFieldCtrl(DioSniperHUD) { 
		profile = "GuiDefaultProfile"; 
		horizSizing = "right"; 
		vertSizing = "bottom"; 
		position = $DioSniper::Pos; 
		extent = %DioSniper::Size;
		minExtent = "8 8";  
		visible = "0";
	};
	
	playgui.add(DioSniperHUD);
	
	DioSniperHUD.graphic = new GuiBitmapCtrl() {
		profile = "GuiDefaultProfile";
		visible = "1";
		opacity = "0.5";
		extent = %DioSniper::Size;
		bitmap = "DioSniperRets/" @ $pref::DioSniper::Reticle @ ".png";
		autoResize = "1";
	};
	DioSniperHUD.add(DioSniperHUD.graphic); 
	
	new GuiControl(DioSniperConfig) {
		profile = "GuiDefaultProfile";
		horizSizing = "center";
		vertSizing = "center";
		position = "0 0";
		extent = "640 480";
		minExtent = "8 8";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
	
		new ShellPaneCtrl() {
			profile = "ShellPaneProfile";
			horizSizing = "center";
			vertSizing = "center";
			position = "0 0";
			extent = "251 341";
			minExtent = "48 92";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "DioSniper";
			longTextBuffer = "0";
			maxLength = "255";
			noTitleBar = "0";
	
			new ShellFieldCtrl() {
				profile = "ShellFieldProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 29";
				extent = "211 259";
				minExtent = "16 18";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
			};
	
			new ShellToggleButton(DioSniperUseLaserButton) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "40 33";
				extent = "180 30";
				minExtent = "26 27";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				variable = "$pref::DioSniper::UseLaser";
				helpTag = "0";
				text = "LASER RIFLE ZOOM";
				maxLength = "255";
			};
			
			new ShellToggleButton(DioSniperNotOnCGButton) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "40 55";
				extent = "180 30";
				minExtent = "26 27";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				variable = "$pref::DioSniper::NotOnCG";
				helpTag = "0";
				text = "NO LASER ZOOM WITH CG";
				maxLength = "255";
			};
			new ShellPopupMenu(DioSniperPopup) {
				profile = "ShellPopupProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "34 89";
				extent = "195 30";
				minExtent = "49 30";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				maxLength = "255";
				maxPopupHeight = "200";
				buttonBitmap = "gui/shll_pulldown";
				rolloverBarBitmap = "gui/shll_pulldownbar_rol";
				selectedBarBitmap = "gui/shll_pulldownbar_act";
				noButtonStyle = "0";
			};
			new GuiChunkedBitmapCtrl(DioSniperPreview) {
				profile = "GuiDefaultProfile";
				visible = "1";
				extent = "200 150";
				bitmap = "DioSniperRets/" @ $pref::DioSniper::Reticle @ ".png";
				position = "26 127";
			};
			
			new ShellBitmapButton() {
				profile = "ShellButtonProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "54 289";
				extent = "140 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				command = "DioSniper::Preview();";
				helpTag = "0";
				text = "Full Screen Preview";
				simpleStyle = "0";
			};
		};
	};
	
	if($pref::DioSniper::Enabled $= ""){
		$pref::DioSniper::Enabled = true;
		$pref::DioSniper::UseLaser = false;
		$pref::DioSniper::NotOnCG = false;
		$pref::DioSniper::Reticle = "DioSniperRet1";
	}

	DioSniperUseLaserButton.setValue($pref::DioSniper::UseLaser);	
	DioSniperNotOnCGButton.setValue($pref::DioSniper::NotOnCG);	
	scriptbrowsergui.add(DioSniperHUD);
	
	callback.add(WeaponChange, DioSniperCheck);
	
	if (!isfile("textures/DioSniperRets/DioSniper-README.txt")) { 
		%file = new FileObject();
	        %file.openForWrite("textures/DioSniperRets/DioSniper-README.txt");
	        %file.writeLine("Place your custom DioSniper reticles in this directory. Once placed in this folder, they will show up on the DioSniper options screen the next time you open T2.");
	        %file.close();
	        %file.delete();
	}
}

function PlayGui::OnWake(){
	playgui.add(DioSniperHUD);
	parent::onwake(%this);
}

function ScriptBrowserGUI::OnWake(){
	DioSniperPopup::Setup();
	parent::onwake(%this);
	scriptbrowsergui.add(DioSniperHUD);
}
	
function DioSniperPopup::Setup(){
	DioSniperPopup.clear();
	%id = 0;
	if ( %validate $= "" || call( %validate, %file ) ){
		for ( %file = findFirstFile( "textures/DioSniperRets/*.png" ); %file !$= ""; %file = findNextFile( "textures/DioSniperRets/*.png" ) ){
			DioSniperPopup.add(fileBase( %file ), %id, 1);
			if(fileBase( %file ) $= $pref::DioSniper::Reticle){
				DioSniperPopup.setSelected(%id);
			}
			%id++;
		}
	}
}

function DioSniperPopup::onSelect(%this, %id, %text) {
	$pref::DioSniper::Reticle = %text;
	DioSniperPreview.setbitmap("DioSniperRets/"@ %text @".png");
	DioSniperHUD.graphic.setbitmap("DioSniperRets/"@ %text @".png");
	DioSniperPopup.setSelected(%id);
}

function DioSniper::Preview(%this){
	DioSniperHUD.setVisible(1);
	schedule(3000, 0, DioSniperHide);
}

function DioSniperHide(%this){
	DioSniperHUD.setVisible(0);
}


};

activatePackage(DioSniper);
DioSniper::Start();